
// mobile_robot_EKF_camera_landmarkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "mobile_robot_EKF_camera_landmark.h"
#include "mobile_robot_EKF_camera_landmarkDlg.h"

#include "log.h"
#include "mrs_rpc.h"
#include "mm.h"
#include "MatrixAlgebra.h"
#include "feature_2d.h"
#include "diff_wheel_robot.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

extern int rpc_client_init();
extern int rpc_client_free();


//  ȭ鿡  ġ m pixel ٲٱ    
#define SCREEN_OFFSET_X		100
#define SCREEN_OFFSET_Y		600
#define SCREEN_SCALE		50

inline int M2Px(double x) { return (int)(SCREEN_OFFSET_X + x*SCREEN_SCALE); }
inline int M2Py(double y) { return (int)(SCREEN_OFFSET_Y - y*SCREEN_SCALE); }
inline int M2Pl(double l) { return (int)(l*SCREEN_SCALE); }

// Cmobile_robot_EKF_camera_landmarkDlg dialog

Cmobile_robot_EKF_camera_landmarkDlg::Cmobile_robot_EKF_camera_landmarkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Cmobile_robot_EKF_camera_landmarkDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void Cmobile_robot_EKF_camera_landmarkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(Cmobile_robot_EKF_camera_landmarkDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// Cmobile_robot_EKF_camera_landmarkDlg message handlers

BOOL Cmobile_robot_EKF_camera_landmarkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	rpc_client_init();

	load_feature2D (".\\map\\feature_2d.txt");

	SetRobotPosition(1, 1, 0);

	double robot_x, robot_y, robot_theta;
	GetRobotPosition(&robot_x, &robot_y, &robot_theta);

	_ekf = new CEKF(robot_x, robot_y, robot_theta);

	GetMotorPosition(&_leftWheelPrev, &_rightWheelPrev);

	SetTimer (1000, 100, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Cmobile_robot_EKF_camera_landmarkDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // device context for painting

		if (_memDC.GetSafeHdc() == NULL) {
			GetClientRect (&_memDCRect);

			_memDC.CreateCompatibleDC(&dc);
			_bitmap.CreateCompatibleBitmap(&dc, _memDCRect.Width(), _memDCRect.Height());
			_bitmapOld = _memDC.SelectObject(&_bitmap);
			ASSERT (_bitmapOld);

			DrawBackground (_memDC, 10, 15);
		}

		if (_memDC.GetSafeHdc() != NULL) {
			dc.BitBlt(_memDCRect.left, _memDCRect.top, _memDCRect.Width(), _memDCRect.Height(), &_memDC, 0,0, SRCCOPY);
		}

		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Cmobile_robot_EKF_camera_landmarkDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void Cmobile_robot_EKF_camera_landmarkDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	double robot_x, robot_y, robot_theta;

	RpcTryExcept
	{
		//  ̵ оͼ κ ġ  Ѵ.
		double leftWheel, rightWheel;
		GetMotorPosition(&leftWheel, &rightWheel);
		
		double dlm = (leftWheel - _leftWheelPrev)*_wheel_radius;
		double drm = (rightWheel - _rightWheelPrev)*_wheel_radius;

		double sigma_wheel = 0.2;
		dlm += sigma_wheel*dlm*GaussRand ();
		drm += sigma_wheel*drm*GaussRand ();
		
		_ekf->predict(dlm, drm);

		_leftWheelPrev = leftWheel; _rightWheelPrev = rightWheel; 

		//  Feature  Ÿ  оͼ κ ġ Ʈ Ѵ.
		long feature_id;
		double feature_r, feature_theta;

		GetFeatureData(&feature_id, &feature_r, &feature_theta);

		for (unsigned int i=0; i<_feature_2d.size(); ++i) {
			_feature_2d[i].active = false;
		}
		if (0 <= feature_id) {
			_ekf->update(_feature_2d[feature_id].x, _feature_2d[feature_id].y, feature_r, feature_theta);
		
			_feature_2d[feature_id].active = true;
		}

		// κ    ̵ ӵ Ѵ.
		double leftMotorVel = 3.5;
		double rightMotorVel = 4;

		GoMotorVelocity (leftMotorVel, rightMotorVel);

		// ùķͷκ κ  ġ о´.
		GetRobotPosition(&robot_x, &robot_y, &robot_theta);
	}
	RpcExcept(1)
	{
		log ("Runtime exception occured: %l ", (long)RpcExceptionCode());
	}
	RpcEndExcept

	if (_memDC.GetSafeHdc()) {
		DrawBackground (_memDC, 10, 15);
		DrawFeature (_memDC);
		DrawRobot (_memDC, robot_x, robot_y, robot_theta, RGB(0,0,255));
		DrawRobot (_memDC, _ekf->X(0,0), _ekf->X(1,0), _ekf->X(2,0), RGB(0,255,0));
		DrawCovariance (_memDC, _ekf->X(0,0), _ekf->X(1,0), _ekf->P(0,0), _ekf->P(0,1), _ekf->P(1,1));

		char text[1024];

		sprintf (text, "True Robot Position: %.3f, %.3f, %.3f", robot_x, robot_y, robot_theta);
		TextOut (_memDC, 20, 10, text, strlen(text));

		sprintf (text, "Estimated Robot Position: %.3f, %.3f, %.3f", (double)_ekf->X(0,0), (double)_ekf->X(1,0), (double)_ekf->X(2,0));
		TextOut (_memDC, 20, 30, text, strlen(text));

		sprintf (text, "Estimated Robot Covariance: %.3f, %.3f, %.3f", (double)_ekf->P(0,0), (double)_ekf->P(1,1), (double)_ekf->P(2,2));
		TextOut (_memDC, 20, 50, text, strlen(text));
	}

	InvalidateRect (&_memDCRect, FALSE);

	CDialog::OnTimer(nIDEvent);
}

void Cmobile_robot_EKF_camera_landmarkDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	GoMotorVelocity (0, 0);

	if(_ekf)	delete _ekf;
	rpc_client_free();
}


void Cmobile_robot_EKF_camera_landmarkDlg::DrawBackground (CDC &dc, int width, int height)
{
	dc.SelectStockObject (WHITE_PEN);
	dc.SelectStockObject (WHITE_BRUSH);

	dc.Rectangle (0, 0, _memDCRect.Width(), _memDCRect.Height());

	CPen pen (PS_SOLID, 1, RGB(225,225,225));
	dc.SelectObject (pen);

	for (int i=0; i<=width; ++i) {
		dc.MoveTo (M2Px(i), M2Py(0));
		dc.LineTo (M2Px(i), M2Py(height));
	}
	for (int i=0; i<=height; ++i) {
		dc.MoveTo (M2Px(0), M2Py(i));
		dc.LineTo (M2Px(width), M2Py(i));
	}
}

void Cmobile_robot_EKF_camera_landmarkDlg::DrawFeature (CDC &dc)
{
	CPen pen (PS_SOLID, 1, RGB(0,64,0));
	dc.SelectObject (pen);

	CBrush brush_active ( RGB(0,255,0));
	CBrush brush_inactive ( RGB(0,127,0));

	for (unsigned int i=0; i<_feature_2d.size(); ++i) {
		int rx = M2Px(_feature_2d[i].x);
		int ry = M2Py(_feature_2d[i].y);
		int rr = M2Pl(_feature_2d[i].r/2);
		
		dc.SelectObject (_feature_2d[i].active ? brush_active : brush_inactive);
		dc.Ellipse (rx-rr, ry-rr, rx+rr, ry+rr);
	}
}

void Cmobile_robot_EKF_camera_landmarkDlg::DrawRobot (CDC &dc, double x, double y, double theta, COLORREF color)
{
	dc.SelectStockObject (WHITE_BRUSH);

	CPen pen (PS_SOLID, 2, color);
	dc.SelectObject (pen);

	int rx = M2Px(x);
	int ry = M2Py(y);
	int rr = M2Pl(_axle_length/2);

	int dx = (int)(rr*cos(theta));
	int dy = (int)(rr*sin(theta));

	dc.Ellipse (rx-rr, ry-rr, rx+rr, ry+rr);
	dc.MoveTo (rx, ry);
	dc.LineTo (rx+dx, ry-dy);
}

void Cmobile_robot_EKF_camera_landmarkDlg::DrawCovariance (CDC &dc, double x, double y, double s_xx, double s_xy, double s_yy)
{
	CPen pen (PS_SOLID, 1, RGB(255,0,0));
	dc.SelectObject (pen);

	dMatrix C(2,2);

	C(0,0) = s_xx;
	C(0,1) = C(1,0) = s_xy;
	C(1,1) = s_yy;

	dVector D;
	dMatrix V;

	if (C.eigen(D, V)) {
		for (unsigned int i = 0; i<D.size(); ++i) {
			D[i] = sqrt(D[i]);
		}

		for (unsigned int i=0; i<=360; i+=10) {
			double ri = _DEG2RAD*i;

			double ax = D[0]*cos(ri);
			double ay = D[1]*sin(ri);

			double rx = V(0,0)*ax + V(0,1)*ay;
			double ry = V(1,0)*ax + V(1,1)*ay;

			if(i==0) dc.MoveTo (M2Px(x + rx), M2Py(y + ry));
			else     dc.LineTo (M2Px(x + rx), M2Py(y + ry));
		}
	}
}